﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;
using UnityEngine.UI;
public class Manager : MonoBehaviour {
    public GameObject Object1;//Object dari Tool
    public GameObject Object2;//Object Grid
    public TextMesh PowerBar;
    public GameObject Arena;
    public GameObject GameOverScreen;
    public GameObject WinScreen;
    public int CheckpointLevel;

    private void Start()
    {
        Destroy(GameObject.Find("SoundSystem"));
    }

    public void CekandGetData()
    {
        if (Object1 != null && Object2 != null)
        {
            //Object2.GetComponent<SpriteRenderer>().color = Object1.GetComponent<Image>().color;
            Object2.GetComponent<SpriteRenderer>().sprite = Object1.GetComponent<Image>().sprite;
            Object2.GetComponent<SpriteRenderer>().transform.localScale = new Vector3(0.5f, 0.5f, 0.5f);
            Object2.GetComponent<unclickedGrid>().hascolor = true;
            Object2.GetComponent<unclickedGrid>().Direction = Object1.GetComponent<Tool>().Direction;

            PowerBar.text = (Convert.ToInt32(PowerBar.text)-5)+"";


            var hasil = Object2.GetComponent<unclickedGrid>().Direction;
            bool x = Object2.GetComponent<unclickedGrid>().hascolor;

            if (Convert.ToInt32(PowerBar.text) == 0)
            {
                GameOverScreen.SetActive(true);
                GameObject.Find("SoundSystemSceneTestGame").GetComponent<SoundSystem>().PlayGameOverSound();
            }
            Object1 = null;
            Object2 = null;
        }
    }

    //mengecek Kemenangan player
    public void CheckWin()
    {
        Stack<GameObject> stackLangkah = new Stack<GameObject>();
        GameObject[,] grid = Arena.GetComponent<GridSpawn>().thisarena;
        
        int pointerX = 0;
        int pointerY = 0;
        int actualX = 0;
        int actualY = 0;
        bool notFinished = true;
        string directionString="bawah";
        int banyakKotak = Arena.GetComponent<GridSpawn>().BanyakKotak;
        
        for (int i = 0; i < banyakKotak; i++)
        {
            for (int j = 0; j < banyakKotak; j++)
            {
                grid[i, j].GetComponent<unclickedGrid>().canWalk = true;
            }
        }

        

        while (notFinished)
        {
            pointerX = actualX;
            pointerY = actualY;
            grid[pointerX, pointerY].GetComponent<unclickedGrid>().canWalk = false;

            Dictionary<String, String> Keys = new Dictionary<string, string>();

            //Mengecek direction selanjutnya
            try
            {
                Keys = grid[pointerX, pointerY].GetComponent<unclickedGrid>().Direction;
            }
            catch (Exception ex) { }

            try
            { directionString = Keys[directionString]; }
            catch (Exception ex)
            {
                Debug.Log("Game Over Tidak Samapai");
                return;
            }

            if (directionString == "kiri")
            {
                try//jalan kiri
                {
                    pointerY = pointerY - 1;
                    bool canWalk = grid[pointerX, pointerY].GetComponent<unclickedGrid>().canWalk;
                    bool hasColor = grid[pointerX, pointerY].GetComponent<unclickedGrid>().hascolor;
                    if (hasColor == true && canWalk == true)
                    {
                        stackLangkah.Push(grid[pointerX, pointerY]);
                    }

                }
                catch (Exception ex) { }

                pointerX = actualX;
                pointerY = actualY;
            }
            else if (directionString == "bawah")
            {
                try// jalan bawah
                {
                    pointerX = pointerX + 1;
                    bool canWalk = grid[pointerX, pointerY].GetComponent<unclickedGrid>().canWalk;
                    bool hasColor = grid[pointerX, pointerY].GetComponent<unclickedGrid>().hascolor;
                    if (hasColor == true && canWalk == true)
                    {
                        stackLangkah.Push(grid[pointerX, pointerY]);
                    }

                }
                catch (Exception ex) { }

                pointerX = actualX;
                pointerY = actualY;
            }
            else if (directionString == "kanan")
            {
                try//jalan kanan
                {
                    pointerY = pointerY + 1;
                    bool canWalk = grid[pointerX, pointerY].GetComponent<unclickedGrid>().canWalk;
                    bool hasColor = grid[pointerX, pointerY].GetComponent<unclickedGrid>().hascolor;
                    if (hasColor == true && canWalk == true)
                    {
                        stackLangkah.Push(grid[pointerX, pointerY]);
                    }

                }
                catch (Exception ex) { }

                pointerX = actualX;
                pointerY = actualY;
            }
            else if (directionString == "atas")
            {
                try//jalan atas
                {
                    pointerX = pointerX - 1;
                    bool canWalk = grid[pointerX, pointerY].GetComponent<unclickedGrid>().canWalk;
                    bool hasColor = grid[pointerX, pointerY].GetComponent<unclickedGrid>().hascolor;
                    if (hasColor == true && canWalk == true)
                    {
                        stackLangkah.Push(grid[pointerX, pointerY]);
                    }

                }
                catch (Exception ex) { }

                pointerX = actualX;
                pointerY = actualY;
            }

            if (stackLangkah.Count > 0)
            {
                var mod = stackLangkah.Pop();
                actualX = mod.GetComponent<unclickedGrid>().positionX;
                actualY = mod.GetComponent<unclickedGrid>().positionY;
                if ((actualX == banyakKotak-1 && actualY == banyakKotak - 1))
                {
                    notFinished = false;
                    Debug.Log("Menang");
                    WinScreen.SetActive(true);
                    GameObject.Find("SoundSystemSceneTestGame").GetComponent<SoundSystem>().PlayWinSound();
                }
            }
            else
            {
                notFinished = false;
                Debug.Log("Tidak Sampai(Game Over)");
                //GameOverScreen.SetActive(true);
            }

            Debug.Log(actualX + "," + actualY);
        }

    }

    public void RestartGame()
    {
        GameOverScreen.SetActive(false);
        PowerBar.text = 100+"";
        if (CheckpointLevel > 1)
        {
            Arena.GetComponent<GridSpawn>().InitGrid(false);
        }
        else
        {
            Arena.GetComponent<GridSpawn>().InitGrid(true);
        }
        
    }
    public void NextLevel()
    {
        CheckpointLevel += 1;
        PowerBar.text = 100 + "";
        if (CheckpointLevel  == 3)
        {
            //MENANG!!!!!
            SceneManager.LoadScene(3);
        }
        else if (CheckpointLevel >= 1)
        {
            Arena.GetComponent<GridSpawn>().InitGrid(false,CheckpointLevel);
        }
        else
        { 
            Arena.GetComponent<GridSpawn>().InitGrid(true);
        }
        WinScreen.SetActive(false);
    }
    public void BackToMenu()
    {
        SceneManager.LoadScene(0);
    }
}
